LibreOffice LibreOffice 25.2 SDK API Reference

Public Member Functions | List of all members
XColorSpace Interface Reference

Information how to interpret certain color data. More...

`import"XColorSpace.idl";`

Inheritance diagram for XColorSpace:

## Public Member Functions
byte | getType ()
| Query type of this color space. More...
sequence< byte > | getComponentTags ()
| Query the kind for each color component. More...
byte | getRenderingIntent ()
| Query rendering intent of this color space. More...
sequence< ::com::sun::star::beans::PropertyValue > | getProperties ()
| Query various optional properties from the color space. More...
sequence< ColorComponent > | convertColorSpace ([in] sequence< ColorComponent > deviceColor, [in] XColorSpace targetColorSpace) raises (com::sun::star::lang::IllegalArgumentException)
| Convert to color of another color space. More...
sequence< RGBColor > | convertToRGB ([in] sequence< ColorComponent > deviceColor) raises (com::sun::star::lang::IllegalArgumentException)
| Convert color value in this color space to sRGB color values. More...
sequence< ARGBColor > | convertToARGB ([in] sequence< ColorComponent > deviceColor) raises (com::sun::star::lang::IllegalArgumentException)
| Convert color value in this color space to sRGB color values, with linear alpha. More...
sequence< ARGBColor > | convertToPARGB ([in] sequence< ColorComponent > deviceColor) raises (com::sun::star::lang::IllegalArgumentException)
| Convert color value in this color space to premultiplied sRGB color values, with linear alpha. More...
sequence< ColorComponent > | convertFromRGB ([in] sequence< RGBColor > rgbColor) raises (com::sun::star::lang::IllegalArgumentException)
| Convert sRGB color to a representation in this color space. More...
sequence< ColorComponent > | convertFromARGB ([in] sequence< ARGBColor > rgbColor) raises (com::sun::star::lang::IllegalArgumentException)
| Convert sRGB color with linear alpha into this color space. More...
sequence< ColorComponent > | convertFromPARGB ([in] sequence< ARGBColor > rgbColor) raises (com::sun::star::lang::IllegalArgumentException)
| Convert premultiplied sRGB color with linear alpha into this color space. More...

## Detailed Description

Information how to interpret certain color data.

This interface encapsulates all information that is necessary to interpret color data, by defining a describing color space, like for example CMYK or sRGB. You can either convert between this and an arbitrary other color space, or into the standard RGB or ARGB formats (because those are so overwhelmingly common in computer graphics).

All canvas interfaces standardize to sequences of IEEE doubles for color representation. As this is overly verbose when used for bitmap data, derived interfaces exist, e.g. XIntegerBitmapColorSpace, which use sequences of integers for color representation.

## Member Function Documentation

## ◆ convertColorSpace()

sequence< ColorComponent > convertColorSpace | ( | [in] sequence< ColorComponent > | deviceColor,
|  | [in] XColorSpace | targetColorSpace
| ) |  |
raises | ( | com::sun::star::lang::IllegalArgumentException
| ) |  |

Convert to color of another color space.

Parameters

  deviceColor | Sequence of device color components. Is permitted to contain more than one device color element, therefore, batch conversion of multiple color values is possible.
  targetColorSpace | the color space to convert to.

Returns
  the corresponding sequence of device colors in the target color space (e.g. `sequence<double>` or `sequence<byte>`).

Exceptions

  a | com::sun::star::lang::IllegalArgumentException, if the input sequence does not match the device color format (e.g. if the number of components is wrong)

## ◆ convertFromARGB()

sequence< ColorComponent > convertFromARGB | ( | [in] sequence< ARGBColor > | rgbColor | ) |
raises | ( | com::sun::star::lang::IllegalArgumentException
| ) |  |

Convert sRGB color with linear alpha into this color space.

If this color space does not convey alpha information, the specified alpha value is silently ignored.

Parameters

  rgbColor | Sequence of sRGB color components. Is permitted to contain more than one color element, therefore, batch conversion of multiple color values is possible.

Returns
  the corresponding sequence of device colors.

Exceptions

  a | com::sun::star::lang::IllegalArgumentException, if the input sequence does not match the device color format.

## ◆ convertFromPARGB()

sequence< ColorComponent > convertFromPARGB | ( | [in] sequence< ARGBColor > | rgbColor | ) |
raises | ( | com::sun::star::lang::IllegalArgumentException
| ) |  |

Convert premultiplied sRGB color with linear alpha into this color space.

If this color space does not convey alpha information, the specified alpha value is silently ignored.

Parameters

  rgbColor | Sequence of sRGB color components. Is permitted to contain more than one color element, therefore, batch conversion of multiple color values is possible. The individual color values are assumed to be premultiplied by the alpha value.

Returns
  the corresponding sequence of device colors.

Exceptions

  a | com::sun::star::lang::IllegalArgumentException, if the input sequence does not match the device color format.

## ◆ convertFromRGB()

sequence< ColorComponent > convertFromRGB | ( | [in] sequence< RGBColor > | rgbColor | ) |
raises | ( | com::sun::star::lang::IllegalArgumentException
| ) |  |

Convert sRGB color to a representation in this color space.

If this color space conveys alpha information, it is assumed be fully opaque for the given RGB color value.

Parameters

  rgbColor | Sequence of sRGB color components. Is permitted to contain more than one color element, therefore, batch conversion of multiple color values is possible.

Returns
  the corresponding sequence of device colors.

Exceptions

  a | com::sun::star::lang::IllegalArgumentException, if the input sequence does not match the device color format.

## ◆ convertToARGB()

sequence< ARGBColor > convertToARGB | ( | [in] sequence< ColorComponent > | deviceColor | ) |
raises | ( | com::sun::star::lang::IllegalArgumentException
| ) |  |

Convert color value in this color space to sRGB color values, with linear alpha.

If the given input color does not carry alpha information, an alpha value of 1.0 (fully opaque) is assumed.

Parameters

  deviceColor | Sequence of device color components. Is permitted to contain more than one device color element, therefore, batch conversion of multiple color values is possible.

Returns
  the corresponding sequence of colors in the sRGB color space.

Exceptions

  a | com::sun::star::lang::IllegalArgumentException, if the input sequence does not match the device color format.

## ◆ convertToPARGB()

sequence< ARGBColor > convertToPARGB | ( | [in] sequence< ColorComponent > | deviceColor | ) |
raises | ( | com::sun::star::lang::IllegalArgumentException
| ) |  |

Convert color value in this color space to premultiplied sRGB color values, with linear alpha.

If the given input color does not carry alpha information, an alpha value of 1.0 (fully opaque) is assumed. The resulting individual RGB color values are premultiplied by the alpha value (e.g. if alpha is 0.5, each color value has only half of the original intensity).

Parameters

  deviceColor | Sequence of device color components. Is permitted to contain more than one device color element, therefore, batch conversion of multiple color values is possible.

Returns
  the corresponding sequence of colors in the sRGB color space.

Exceptions

  a | com::sun::star::lang::IllegalArgumentException, if the input sequence does not match the device color format.

## ◆ convertToRGB()

sequence< RGBColor > convertToRGB | ( | [in] sequence< ColorComponent > | deviceColor | ) |
raises | ( | com::sun::star::lang::IllegalArgumentException
| ) |  |

Convert color value in this color space to sRGB color values.

Any information not representable in the RGBColor struct is discarded during the conversion. This includes alpha information.

Parameters

  deviceColor | Sequence of device color components. Is permitted to contain more than one device color element, therefore, batch conversion of multiple color values is possible.

Returns
  the corresponding sequence of colors in the sRGB color space.

Exceptions

  a | com::sun::star::lang::IllegalArgumentException, if the input sequence does not match the device color format.

See also
  convertToARGB()

## ◆ getComponentTags()

sequence< byte > getComponentTags | ( |  | ) |

Query the kind for each color component.

Color space components tend to correspond to physical attributes like the amount of one specific colorant contained in the final output color. This method returns a sequence of tags, specifying for each component of a color value, to what color attribute (if any) it corresponds. The values must be one of the ColorComponentTag constants.

At the same time, the number of elements in this sequence corresponds to the number of color channels for this color space.

Remarks
  For the standard RGB color space, ComponentTags consists of three elements, containing RGB_RED, RGB_GREEN and RGB_BLUE tags, respectively

## ◆ getProperties()

sequence< ::com::sun::star::beans::PropertyValue > getProperties | ( |  | ) |

Query various optional properties from the color space.

If this color space has an ICC color profile, the sequence contains an element named ICCProfile. Some color spaces also have properties Gamma, Whitepoint and Blackpoint. Background information for these is available here.

## ◆ getRenderingIntent()

byte getRenderingIntent | ( |  | ) |

Query rendering intent of this color space.

Returns
  a value from the RenderingIntent constant group.

## ◆ getType()

byte getType | ( |  | ) |

Query type of this color space.

Returns
  a value from the ColorSpaceType constant group.

The documentation for this interface was generated from the following file:

- com/sun/star/rendering/XColorSpace.idl